from widget import Widget
from tkinter import messagebox
import tkinter as tk
import tkinter.ttk as ttk
import pandas as pd
import matplotlib

matplotlib.use('TkAgg')


class Container(tk.Tk):

    def __init__(self):
        super().__init__()
        self.__process_bt_vegg = None
        self.__back_bt_vegg = None
        self.__widget_vegg_tab = None
        self.__process_bt_fruit = None
        self.__back_bt_fruit = None
        self.__back_bt_vegg2 = None
        self.__widget_fruit_tab = None
        self.__tab_vegg = None
        self.__back_bt_fruit2 = None
        self.__tab_fruit = None
        self.__notebook = None
        self.__quit_bt = None
        self.__start_bt = None
        self.__widget_page1 = None
        self.__tab_fruit_bg = "#FFBF9B"
        self.__tab_vegg_bg = "#B6EADA"

        self.__SCREEN_WIDTH = self.winfo_screenwidth()
        self.__SCREEN_HEIGHT = self.winfo_screenheight()

        self.__fruit_df = pd.read_csv("fruits.csv")
        self.__veggie_df = pd.read_csv("vegetables.csv")

        self.clear_null_data()

        self.title("Fruity & Veggies")
        self.geometry(f"{self.__SCREEN_WIDTH}x{self.__SCREEN_HEIGHT}")

        self.config(bg='lightgray')  # change background color

        self.home_page()

    def clear_null_data(self):
        self.__fruit_df = self.__fruit_df.replace('-', None)
        self.__fruit_df = self.__fruit_df.dropna()
        self.__fruit_df = self.__fruit_df.reset_index(drop=True)

        self.__veggie_df = self.__veggie_df.replace('-', None)
        self.__veggie_df = self.__veggie_df.dropna()
        self.__veggie_df = self.__veggie_df.reset_index(drop=True)

    def home_page(self):
        self.__widget_page1 = Widget(root=self,
                                     bg='lightgray')
        self.__widget_page1.page1()
        self.__start_bt = tk.Button(self,
                                    text="Start",
                                    font=('arial', 20, 'bold'),
                                    width=10,
                                    height=3,
                                    command=self.home_page2)
        self.__start_bt.grid(row=2, column=0, pady=50)

        self.__quit_bt = tk.Button(self,
                                   text="Quit",
                                   font=('arial', 20, 'bold'),
                                   command=self.quit,
                                   width=10,
                                   height=3)
        self.__quit_bt.grid(row=2, column=1, pady=50)

    def quit(self):
        self.destroy()

    def home_page2(self):
        self.bell()
        self.__widget_page1.destroy_page1()
        self.__start_bt.destroy()
        self.__quit_bt.destroy()

        self.__notebook = ttk.Notebook(width=self.__SCREEN_WIDTH - 50, height=self.__SCREEN_HEIGHT - 280)
        style = ttk.Style()

        style.configure('CustomNotebook.TNotebook', borderwidth=2)

        self.__tab_fruit = tk.Frame(self.__notebook, background=self.__tab_fruit_bg)
        self.__tab_vegg = tk.Frame(self.__notebook, background=self.__tab_vegg_bg)

        self.__notebook.add(self.__tab_fruit, text='Fruit')
        self.__notebook.add(self.__tab_vegg, text='Vegetable')

        self.__notebook.grid(row=1, column=0)

        self.fruit_tab()
        self.vegg_tab()

        style = ttk.Style()
        style.configure('TNotebook.Tab', foreground='blue')

    def process_page_fruit(self):
        if self.__widget_fruit_tab.get_graph_type() == 'Pie Chart':
            if self.__widget_fruit_tab.check_piechart():
                self.__back_bt_fruit.destroy()

                self.__process_bt_fruit.destroy()

                self.__widget_fruit_tab.destroy_widget_page2()

                self.__widget_fruit_tab.page3()

            else:
                messagebox.showwarning("Warning❗️", "Please complete the selection❗")

        if self.__widget_fruit_tab.check_element_treeview():

            self.__back_bt_fruit.destroy()

            self.__process_bt_fruit.destroy()

            self.__widget_fruit_tab.destroy_widget_page2()

            self.__widget_fruit_tab.page3()

        else:
            messagebox.showwarning("Warning❗️", "Please choose item at least 1❗")

        self.__back_bt_fruit2 = tk.Button(self.__tab_fruit,
                                          text="Back",
                                          font=('arial', 30, 'bold'),
                                          command=self.back_to_page2_fruit)
        self.__back_bt_fruit2.grid(row=4, column=1, padx=30, sticky='w')

    def process_page_vegg(self):
        if self.__widget_vegg_tab.get_graph_type() == 'Pie Chart':
            if self.__widget_vegg_tab.check_piechart():
                self.__back_bt_vegg.destroy()

                self.__process_bt_vegg.destroy()

                self.__widget_vegg_tab.destroy_widget_page2()

                self.__widget_vegg_tab.page3()
            else:
                messagebox.showwarning("Warning❗️", "Please complete the selection❗")

        if self.__widget_vegg_tab.check_element_treeview():
            self.__back_bt_vegg.destroy()

            self.__process_bt_vegg.destroy()

            self.__widget_vegg_tab.destroy_widget_page2()

            self.__widget_vegg_tab.page3()

        else:
            messagebox.showwarning("Warning❗️", "Please choose item at least 1❗")

        self.__back_bt_vegg2 = tk.Button(self.__tab_vegg,
                                         text="Back",
                                         font=('arial', 30, 'bold'),
                                         command=self.back_to_page2_vegg)
        self.__back_bt_vegg2.grid(row=4, column=1, padx=30, sticky='w')

    def back_to_page2_fruit(self):
        self.__widget_fruit_tab.destroy_widget_page3()
        self.__back_bt_fruit2.destroy()
        self.home_page2()

    def back_to_page2_vegg(self):
        self.__widget_vegg_tab.destroy_widget_page3()
        self.__back_bt_vegg2.destroy()
        self.home_page2()

    def fruit_tab(self):
        self.__widget_fruit_tab = Widget(root=self.__tab_fruit,
                                         bg=self.__tab_fruit_bg,
                                         label='Fruit',
                                         df=self.__fruit_df)
        self.__widget_fruit_tab.page2()

        self.__back_bt_fruit = tk.Button(self.__tab_fruit,
                                         text="Back",
                                         font=('arial', 30, 'bold'),
                                         command=self.back_to_home,
                                         )
        self.__back_bt_fruit.grid(row=4, column=0, padx=30)

        self.__process_bt_fruit = tk.Button(self.__tab_fruit,
                                            text="Process",
                                            font=('arial', 30, 'bold'),
                                            command=self.process_page_fruit,
                                            )
        self.__process_bt_fruit.grid(row=4, column=1, padx=30)

    def vegg_tab(self):
        self.__widget_vegg_tab = Widget(root=self.__tab_vegg,
                                        bg=self.__tab_vegg_bg,
                                        label='Vegetable',
                                        df=self.__veggie_df)
        self.__widget_vegg_tab.page2()

        self.__back_bt_vegg = tk.Button(self.__tab_vegg,
                                        text="Back",
                                        font=('arial', 30, 'bold'),
                                        command=self.back_to_home,
                                        )
        self.__back_bt_vegg.grid(row=4, column=0, padx=30)

        self.__process_bt_vegg = tk.Button(self.__tab_vegg,
                                           text="Process",
                                           font=('arial', 30, 'bold'),
                                           command=self.process_page_vegg,
                                           )
        self.__process_bt_vegg.grid(row=4, column=1, padx=30)

    def back_to_home(self):
        self.bell()
        self.__notebook.destroy()
        self.home_page()
