import matplotlib.pyplot as plt
import seaborn as sns


class GraphProcessor:
    def __init__(self, df=None, nutrient=None, title=None):
        self.__fontsize = 8

        self.__df = df
        self.__nutrient = nutrient
        self.__title = title

        self.fig = plt.figure()
        self.ax = self.fig.add_subplot()
        self.fig.set_size_inches(7, 6)
        self.fig.subplots_adjust(bottom=0.4)

        plt.title(self.__title)

    def energy_process(self):
        pass

    def fat_process(self):
        pass

    def bar_processor(self):
        sns.barplot(data=self.__df, x='name', y=self.__nutrient)

        plt.xticks(rotation=90, fontsize=self.__fontsize)
        plt.xlabel("hello")

        plt.ylabel(self.__nutrient)

    def hist_processor(self):
        sns.histplot(data=self.__df, x=self.__nutrient)
        plt.xticks(rotation=45, ha='right')

    def boxplot_processor(self):
        sns.boxplot(data=self.__df, x=self.__nutrient)

    def scatter_processor(self, nutrient2):
        sns.scatterplot(data=self.__df, y=self.__nutrient, x=nutrient2)
        plt.xticks(fontsize=self.__fontsize)

    def pie_processor(self):
        plt.pie(list(self.__df['value']), labels=list(self.__df['label']), autopct='%1.2f%%')
        plt.title(self.__df['name'][0])
